diff --git a/multi-functions-samples/pom.xml b/multi-functions-samples/pom.xml
index 743f0d6..fbbd5b1 100644
--- a/multi-functions-samples/pom.xml
+++ b/multi-functions-samples/pom.xml
@@ -2,10 +2,10 @@
4.0.0
io.spring.cloud.stream.sample
- multi-io-samples
+ multi-functions-samples
0.0.1-SNAPSHOT
pom
- multi-io-samples
+ multi-functions-samples
Collection of Spring Cloud Stream Aggregate Samples
diff --git a/transaction-kafka-samples/.mvn b/transaction-kafka-samples/.mvn
new file mode 120000
index 0000000..d21aa17
--- /dev/null
+++ b/transaction-kafka-samples/.mvn
@@ -0,0 +1 @@
+../../.mvn
\ No newline at end of file
diff --git a/transaction-kafka-samples/README.adoc b/transaction-kafka-samples/README.adoc
index 8a9416c..3b5cd18 100644
--- a/transaction-kafka-samples/README.adoc
+++ b/transaction-kafka-samples/README.adoc
@@ -14,7 +14,7 @@ d. all this as a single transaction
4. transaction-logger-sink litsen to person-command and log out
=== How to start sample
-Start kafka, zookeeper and mariaDb with `docker-compuse up -d` in this folder.
+Start kafka, zookeeper and mariaDb with `docker-compose up -d` in this folder.
Start each of the individual submodules in this project. Either in your IDE or by running `mvn spring:boot run` in each subfolder.
Send a POST request to localhost:9997
diff --git a/transaction-kafka-samples/mvnw b/transaction-kafka-samples/mvnw
new file mode 100755
index 0000000..2d1e3cf
--- /dev/null
+++ b/transaction-kafka-samples/mvnw
@@ -0,0 +1,225 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven2 Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Migwn, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+ # TODO classpath?
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`which java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+echo $MAVEN_PROJECTBASEDIR
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/transaction-kafka-samples/mvnw.cmd b/transaction-kafka-samples/mvnw.cmd
new file mode 100644
index 0000000..86846ae
--- /dev/null
+++ b/transaction-kafka-samples/mvnw.cmd
@@ -0,0 +1,143 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven2 Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
diff --git a/transaction-kafka-samples/transaction-http-source/pom.xml b/transaction-kafka-samples/transaction-http-source/pom.xml
index 6e3a1c0..b6d6481 100644
--- a/transaction-kafka-samples/transaction-http-source/pom.xml
+++ b/transaction-kafka-samples/transaction-http-source/pom.xml
@@ -9,25 +9,57 @@
Transaction http source
- io.spring.cloud.stream.sample
- spring-cloud-stream-samples-parent
- 0.0.1-SNAPSHOT
- ../..
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.2.0.RELEASE
+
+
+ Hoxton.BUILD-SNAPSHOT
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-dependencies
+ ${spring-cloud.version}
+ pom
+ import
+
+
+
-
- org.springframework.cloud
- spring-cloud-stream-schema
- 3.0.0.BUILD-SNAPSHOT
-
org.springframework.cloud
spring-cloud-stream-binder-kafka
-
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.springframework.kafka
+ spring-kafka-test
+ test
+
+
+ org.springframework.boot
+ spring-boot-starter-actuator
+
+
+ org.springframework.boot
+ spring-boot-starter
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
@@ -36,4 +68,55 @@
+
+
+
+ spring-snapshots
+ Spring Snapshots
+ https://repo.spring.io/libs-snapshot-local
+
+ true
+
+
+ false
+
+
+
+ spring-milestones
+ Spring Milestones
+ https://repo.spring.io/libs-milestone-local
+
+ false
+
+
+
+
+
+ spring-snapshots
+ Spring Snapshots
+ https://repo.spring.io/libs-snapshot-local
+
+ true
+
+
+ false
+
+
+
+ spring-milestones
+ Spring Milestones
+ https://repo.spring.io/libs-milestone-local
+
+ false
+
+
+
+ spring-releases
+ Spring Releases
+ https://repo.spring.io/libs-release-local
+
+ false
+
+
+
diff --git a/transaction-kafka-samples/transaction-http-source/src/main/java/sample/producer/ProducerApplication.java b/transaction-kafka-samples/transaction-http-source/src/main/java/sample/producer/ProducerApplication.java
index 1e5353c..1787650 100644
--- a/transaction-kafka-samples/transaction-http-source/src/main/java/sample/producer/ProducerApplication.java
+++ b/transaction-kafka-samples/transaction-http-source/src/main/java/sample/producer/ProducerApplication.java
@@ -16,14 +16,16 @@
package sample.producer;
import java.util.StringJoiner;
+import java.util.concurrent.BlockingQueue;
+import java.util.concurrent.LinkedBlockingQueue;
+import java.util.function.Supplier;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
+
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
-import org.springframework.cloud.stream.annotation.EnableBinding;
-import org.springframework.cloud.stream.messaging.Source;
-import org.springframework.messaging.support.MessageBuilder;
+import org.springframework.context.annotation.Bean;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
@@ -32,17 +34,12 @@ import org.springframework.web.bind.annotation.RestController;
* @author Bjarte Stien Karlsen
*/
@SpringBootApplication
-@EnableBinding(Source.class)
@RestController
public class ProducerApplication {
private final Logger logger = LoggerFactory.getLogger(this.getClass().getName());
- private Source source;
- public ProducerApplication(Source source) {
-
- this.source = source;
- }
+ BlockingQueue unbounded = new LinkedBlockingQueue<>();
public static void main(String[] args) {
SpringApplication.run(ProducerApplication.class, args);
@@ -53,9 +50,14 @@ public class ProducerApplication {
PersonEvent personEvent = new PersonEvent();
personEvent.setType("CreatePerson");
personEvent.setName(incomming.getName());
- source.output().send(MessageBuilder.withPayload(personEvent).build());
- logger.info("Person sendt={}", personEvent);
- return "Person sendt";
+ unbounded.offer(personEvent);
+ logger.info("Person sent={}", personEvent);
+ return "Person sent";
+ }
+
+ @Bean
+ public Supplier supplier() {
+ return () -> unbounded.poll();
}
static class PersonEvent {
diff --git a/transaction-kafka-samples/transaction-http-source/src/main/resources/application.yml b/transaction-kafka-samples/transaction-http-source/src/main/resources/application.yml
index 296fba8..2fac30f 100644
--- a/transaction-kafka-samples/transaction-http-source/src/main/resources/application.yml
+++ b/transaction-kafka-samples/transaction-http-source/src/main/resources/application.yml
@@ -2,6 +2,6 @@ spring:
cloud:
stream:
bindings:
- output:
+ supplier-out-0:
destination: person-command
server.port: 9997
diff --git a/transaction-kafka-samples/transaction-logger-sink/pom.xml b/transaction-kafka-samples/transaction-logger-sink/pom.xml
index 377cae4..1e4e2cf 100644
--- a/transaction-kafka-samples/transaction-logger-sink/pom.xml
+++ b/transaction-kafka-samples/transaction-logger-sink/pom.xml
@@ -9,18 +9,55 @@
Schema Registry Consumer
- io.spring.cloud.stream.sample
- spring-cloud-stream-samples-parent
- 0.0.1-SNAPSHOT
- ../..
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.2.0.RELEASE
+
+
+ Hoxton.BUILD-SNAPSHOT
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-dependencies
+ ${spring-cloud.version}
+ pom
+ import
+
+
+
+
org.springframework.cloud
spring-cloud-stream-binder-kafka
-
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.springframework.kafka
+ spring-kafka-test
+ test
+
+
+ org.springframework.boot
+ spring-boot-starter-actuator
+
+
+ org.springframework.boot
+ spring-boot-starter
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
@@ -31,4 +68,55 @@
+
+
+
+ spring-snapshots
+ Spring Snapshots
+ https://repo.spring.io/libs-snapshot-local
+
+ true
+
+
+ false
+
+
+
+ spring-milestones
+ Spring Milestones
+ https://repo.spring.io/libs-milestone-local
+
+ false
+
+
+
+
+
+ spring-snapshots
+ Spring Snapshots
+ https://repo.spring.io/libs-snapshot-local
+
+ true
+
+
+ false
+
+
+
+ spring-milestones
+ Spring Milestones
+ https://repo.spring.io/libs-milestone-local
+
+ false
+
+
+
+ spring-releases
+ Spring Releases
+ https://repo.spring.io/libs-release-local
+
+ false
+
+
+
diff --git a/transaction-kafka-samples/transaction-logger-sink/src/main/java/sample/processor/ConsumerApplication.java b/transaction-kafka-samples/transaction-logger-sink/src/main/java/sample/processor/ConsumerApplication.java
index c87154d..8234bef 100644
--- a/transaction-kafka-samples/transaction-logger-sink/src/main/java/sample/processor/ConsumerApplication.java
+++ b/transaction-kafka-samples/transaction-logger-sink/src/main/java/sample/processor/ConsumerApplication.java
@@ -16,20 +16,19 @@
package sample.processor;
import java.util.StringJoiner;
+import java.util.function.Consumer;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
+
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
-import org.springframework.cloud.stream.annotation.EnableBinding;
-import org.springframework.cloud.stream.annotation.StreamListener;
-import org.springframework.cloud.stream.messaging.Sink;
+import org.springframework.context.annotation.Bean;
/**
* @author Bjarte Stien Karlsen
*/
@SpringBootApplication
-@EnableBinding(Sink.class)
public class ConsumerApplication {
private final Logger logger = LoggerFactory.getLogger(this.getClass().getName());
@@ -38,9 +37,9 @@ public class ConsumerApplication {
SpringApplication.run(ConsumerApplication.class, args);
}
- @StreamListener(Sink.INPUT)
- public void process(PersonEvent data) {
- logger.info("{}", data);
+ @Bean
+ public Consumer process() {
+ return pe -> logger.info("{}", pe);
}
static class PersonEvent {
diff --git a/transaction-kafka-samples/transaction-logger-sink/src/main/resources/application.yml b/transaction-kafka-samples/transaction-logger-sink/src/main/resources/application.yml
index 21a507a..a0f5585 100644
--- a/transaction-kafka-samples/transaction-logger-sink/src/main/resources/application.yml
+++ b/transaction-kafka-samples/transaction-logger-sink/src/main/resources/application.yml
@@ -2,7 +2,7 @@ spring:
cloud:
stream:
bindings:
- input:
+ process-in-0:
destination: person-event
kafka:
binder:
diff --git a/transaction-kafka-samples/transaction-spring-data-processor/pom.xml b/transaction-kafka-samples/transaction-spring-data-processor/pom.xml
index 5b5166d..370d390 100644
--- a/transaction-kafka-samples/transaction-spring-data-processor/pom.xml
+++ b/transaction-kafka-samples/transaction-spring-data-processor/pom.xml
@@ -10,17 +10,55 @@
- io.spring.cloud.stream.sample
- spring-cloud-stream-samples-parent
- 0.0.1-SNAPSHOT
- ../..
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.2.0.RELEASE
+
+
+ Hoxton.BUILD-SNAPSHOT
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-dependencies
+ ${spring-cloud.version}
+ pom
+ import
+
+
+
+
org.springframework.cloud
spring-cloud-stream-binder-kafka
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.springframework.kafka
+ spring-kafka-test
+ test
+
+
+ org.springframework.boot
+ spring-boot-starter-actuator
+
+
+ org.springframework.boot
+ spring-boot-starter
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
org.springframework.boot
spring-boot-starter-data-jpa
@@ -41,4 +79,55 @@
+
+
+
+ spring-snapshots
+ Spring Snapshots
+ https://repo.spring.io/libs-snapshot-local
+
+ true
+
+
+ false
+
+
+
+ spring-milestones
+ Spring Milestones
+ https://repo.spring.io/libs-milestone-local
+
+ false
+
+
+
+
+
+ spring-snapshots
+ Spring Snapshots
+ https://repo.spring.io/libs-snapshot-local
+
+ true
+
+
+ false
+
+
+
+ spring-milestones
+ Spring Milestones
+ https://repo.spring.io/libs-milestone-local
+
+ false
+
+
+
+ spring-releases
+ Spring Releases
+ https://repo.spring.io/libs-release-local
+
+ false
+
+
+
diff --git a/transaction-kafka-samples/transaction-spring-data-processor/src/main/java/sample/processor/ProcessorApplication.java b/transaction-kafka-samples/transaction-spring-data-processor/src/main/java/sample/processor/ProcessorApplication.java
index fb42bc8..d3672eb 100644
--- a/transaction-kafka-samples/transaction-spring-data-processor/src/main/java/sample/processor/ProcessorApplication.java
+++ b/transaction-kafka-samples/transaction-spring-data-processor/src/main/java/sample/processor/ProcessorApplication.java
@@ -15,26 +15,28 @@
*/
package sample.processor;
+import java.util.StringJoiner;
+import java.util.concurrent.atomic.AtomicBoolean;
+import java.util.function.Function;
+
+import javax.transaction.Transactional;
+
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
-import org.springframework.cloud.stream.annotation.EnableBinding;
-import org.springframework.cloud.stream.annotation.StreamListener;
-import org.springframework.cloud.stream.messaging.Processor;
-import org.springframework.messaging.handler.annotation.SendTo;
+import org.springframework.cloud.stream.config.ListenerContainerCustomizer;
+import org.springframework.context.annotation.Bean;
+import org.springframework.kafka.listener.AbstractMessageListenerContainer;
+import org.springframework.kafka.listener.DefaultAfterRollbackProcessor;
import org.springframework.transaction.annotation.EnableTransactionManagement;
-
-import javax.transaction.Transactional;
-import java.util.StringJoiner;
-import java.util.concurrent.atomic.AtomicBoolean;
+import org.springframework.util.backoff.FixedBackOff;
/**
* @author Bjarte Stien Karlsen
*/
@SpringBootApplication
-@EnableBinding(Processor.class)
@EnableTransactionManagement
public class ProcessorApplication {
@@ -53,29 +55,39 @@ public class ProcessorApplication {
}
@Transactional
- @StreamListener(Processor.INPUT)
- @SendTo(Processor.OUTPUT)
- public PersonEvent process(PersonEvent data) {
- logger.info("Received event={}", data);
- Person person = new Person();
- person.setName(data.getName());
+ @Bean
+ public Function process() {
+ return pe -> {
+ logger.info("Received event={}", pe);
+ Person person = new Person();
+ person.setName(pe.getName());
- if(shouldFail.get()) {
- shouldFail.set(false);
- throw new RuntimeException("Simulated network error");
- } else {
- //We fail every other request as a test
- shouldFail.set(true);
- }
- logger.info("Saving person={}", person);
+ if (shouldFail.get()) {
+ shouldFail.set(false);
+ throw new RuntimeException("Simulated network error");
+ } else {
+ //We fail every other request as a test
+ shouldFail.set(true);
+ }
+ logger.info("Saving person={}", person);
- Person savedPerson = repository.save(person);
+ Person savedPerson = repository.save(person);
- PersonEvent event = new PersonEvent();
- event.setName(savedPerson.getName());
- event.setType("PersonSaved");
- logger.info("Sent event={}", event);
- return event;
+ PersonEvent event = new PersonEvent();
+ event.setName(savedPerson.getName());
+ event.setType("PersonSaved");
+ logger.info("Sent event={}", event);
+ return event;
+ };
+ }
+
+ @Bean
+ public ListenerContainerCustomizer> customizer() {
+ // Disable retry in the AfterRollbackProcessor
+ return (container, destination, group) -> container.setAfterRollbackProcessor(
+ new DefaultAfterRollbackProcessor(
+ (record, exception) -> System.out.println("Discarding failed record: " + record),
+ new FixedBackOff(0L, 0)));
}
static class PersonEvent {
diff --git a/transaction-kafka-samples/transaction-spring-data-processor/src/main/resources/application.yml b/transaction-kafka-samples/transaction-spring-data-processor/src/main/resources/application.yml
index 00760e7..23a6ffe 100644
--- a/transaction-kafka-samples/transaction-spring-data-processor/src/main/resources/application.yml
+++ b/transaction-kafka-samples/transaction-spring-data-processor/src/main/resources/application.yml
@@ -1,19 +1,29 @@
spring:
- cloud.stream:
- bindings:
- input.destination: person-command
- output.destination: person-event
- kafka.binder.transaction:
+ cloud:
+ stream:
+ bindings:
+ process-in-0:
+ destination: person-command
+ consumer:
+ maxAttempts: 1
+ process-out-0:
+ destination: person-event
+
+ kafka:
+ binder:
+ transaction:
transaction-id-prefix: person-
producer:
configuration:
retries: 1
acks: all
- datasource:
- url: jdbc:mariadb://localhost:3306/sample_mysql_db
- username: root
- password: pwd
- driver-class-name: org.mariadb.jdbc.Driver
- jpa.hibernate.ddl-auto: create-drop
-server.port: 9998
+ datasource:
+ url: jdbc:mariadb://localhost:3306/sample_mysql_db
+ username: root
+ password: pwd
+ driver-class-name: org.mariadb.jdbc.Driver
+ jpa:
+ hibernate:
+ ddl-auto: create-drop
+server.port: 9998
\ No newline at end of file